﻿// ECMAScript 5 strict mode
"use strict";

assert2(cr, "cr namespace not created");
assert2(cr.plugins_, "cr.plugins_ not created");


cr.plugins_.djz_CordovaAppMetrica = function(runtime)
{
	this.runtime = runtime;
};

(function ()
{
	var pluginProto = cr.plugins_.djz_CordovaAppMetrica.prototype;
		
	// Object type class
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};

	var typeProto = pluginProto.Type.prototype;
	
	// called on startup for each object type
	typeProto.onCreate = function()
	{		
		if(this.runtime.isBlackberry10 || this.runtime.isWindows8App || this.runtime.isWindowsPhone8 || this.runtime.isWindowsPhone81){
			var scripts=document.getElementsByTagName("script");
			var scriptExist=false;
			for(var i=0;i<scripts.length;i++){
				if(scripts[i].src.indexOf("cordova.js")!=-1||scripts[i].src.indexOf("phonegap.js")!=-1){
					scriptExist=true;
					break;
				}
			}
			if(!scriptExist){
				var newScriptTag=document.createElement("script");
				newScriptTag.setAttribute("type","text/javascript");
				newScriptTag.setAttribute("src", "cordova.js");
				document.getElementsByTagName("head")[0].appendChild(newScriptTag);
			}
		}	
	};

	/////////////////////////////////////
	// Instance class
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		
		// any other properties you need, e.g...
		// this.myValue = 0;
	};
	
	var instanceProto = pluginProto.Instance.prototype;

	// called whenever an instance is created
	instanceProto.onCreate = function()
	{
		// note the object is sealed after this call; ensure any properties you'll ever need are set on the object
		// e.g...
		// this.myValue = 0;

		if (!(this.runtime.isAndroid || this.runtime.isiOS))
			return;			
		
        if (typeof window.appMetrica == 'undefined')
           return;

		this.appMetricApiKey = "";

		this.appMetricApiKey = this.properties[0];
		
		if (this.appMetricApiKey == '')
			return;
		
		var self = this;

		document.addEventListener('deviceready', function(){	

			var configuration = {
				// Mandatory
				apiKey: self.appMetricApiKey,
				// Optional
				trackLocationEnabled: true,
				handleFirstActivationAsUpdateEnabled: true,
				sessionTimeout: 15
			}

			window.appMetrica.activate(configuration);
		}, false);
				
	};
	
	// only called if a layout object - draw to a canvas 2D context
	instanceProto.draw = function(ctx)
	{
	};
	
	// only called if a layout object in WebGL mode - draw to the WebGL context
	// 'glw' is not a WebGL context, it's a wrapper - you can find its methods in GLWrap.js in the install
	// directory or just copy what other plugins do.
	instanceProto.drawGL = function (glw)
	{
	};
	
	//////////////////////////////////////
	// Conditions
	function Cnds() {};

/*
	// the example condition
	Cnds.prototype.MyCondition = function (myparam)
	{
		// return true if number is positive
		return myparam >= 0;
	};
*/
	
	Cnds.prototype.OnTimeout = function ()
	{
		return true;
	};
	
	// ... other conditions here ...
	
	pluginProto.cnds = new Cnds();
	
	//////////////////////////////////////
	// Actions
	function Acts() {};

/*
	// the example action
	Acts.prototype.MyAction = function (myparam)
	{
		if (!(this.runtime.isAndroid || this.runtime.isBlackberry10 || this.runtime.isiOS || this.runtime.isWindows8App || this.runtime.isWindowsPhone8 || this.runtime.isWindowsPhone81))
			return;			
		if (this.runtime.isAndroid && navigator.platform == 'Win32')//crosswalk emulator
			return;
			
		// alert the message
		alert(myparam);
	};
*/
	
	Acts.prototype.Activate = function ()
	{
		
		if (!(this.runtime.isAndroid || this.runtime.isiOS))
			return;			
        if (typeof window.appMetrica == 'undefined')
           return;
		
		var self = this;
	};	
	


	Acts.prototype.ReportEvent = function (event, strObj)
	{
		var obj = eval('('+strObj+')');

		if (!(this.runtime.isAndroid || this.runtime.isiOS))
			return;			
        if (typeof window.appMetrica == 'undefined')
           return;

		if (Object.keys(obj).length === 0) {
			window.appMetrica.reportEvent(event);
		} else {
			window.appMetrica.reportEvent(event, obj);
		}
	};	

	Acts.prototype.SetSessionTimeout = function (val)
	{
		if (!(this.runtime.isAndroid || this.runtime.isiOS))
			return;			
        if (typeof window.appMetrica == 'undefined')
           return;

		window.appMetrica.setSessionTimeout(val);
	};		
	
	// ... other actions here ...
	
	pluginProto.acts = new Acts();
	
	//////////////////////////////////////
	// Expressions
	function Exps() {};
	
/*	
	// the example expression
	Exps.prototype.CellXCount = function (ret)	// 'ret' must always be the first parameter - always return the expression's result through it!
	{
		ret.set_int(1337);				// return our value
		// ret.set_float(0.5);			// for returning floats
		// ret.set_string("Hello");		// for ef_return_string
		// ret.set_any("woo");			// for ef_return_any, accepts either a number or string
	};
*/
	
	
	// ... other expressions here ...
	
	pluginProto.exps = new Exps();

}());